#include <HCSR04.h>  //We load the HCSR04.h library into the code
#include <Servo.h>   //We load the servo library into the code

Servo servoDoor;    //we declare the door servo
Servo servoSpider;  //we declare the spider servo
HCSR04 hc(5, 6);    //initialisation class HCSR04 (trig pin , echo pin)

int posDoor, posSpider;
bool open = false;


void setup() {
  Serial.begin(9600);
  servoDoor.attach(10);    //we declare pin 10 for the door servo
  servoSpider.attach(11);  //we declare pin 11 for the spider servo
  pinMode(7, OUTPUT);      //we declare pin 7 as output for the LEDs
}

void loop() {
  //In order to see the distance detected by the sensor, we make it write this distance
  Serial.println(hc.dist());
  delay(10);

  //when the distance is less or equal than 45 cm, it will go to the opendoor function and after 500ms it will go to afteropen, until the distance becomes larger than 45 cm again.
  if (hc.dist() <= 45 && open == false) {
    openDoor();
    delay(500);
    afterOpen();
  }
  //when the distance is more than 45 cm, it will go to the beforecloseDoor function and after 500ms it will go to closeDoor, until the distance becomes smaller than 45 cm again.
  else if (hc.dist() > 45 && open == true) {
    beforeCloseDoor();
    delay(500);
    closeDoor();
  }

  //while the distance is less o equal than 45 cm, the spider servo it will go from 0 degrees to 60 degrees, until the distance becomes larger than 45 cm again.
  while (hc.dist() <= 45 && open == true) {
    servoSpider.write(60);
    delay(400);
    servoSpider.write(0);
    delay(400);
  }
}

//When this function is called the door will open, the LEDs are also turned on, and finally a delay of 500ms is applied.
void openDoor() {
  servoDoor.write(90);
  digitalWrite(7, HIGH);
  delay(250);
  open = true;
}
// When this function is called the spider servo it will go from 0 degrees to 60 degrees
void afterOpen() {
  servoSpider.write(60);
}
// When this function is called the spider servo it will go to 0 degrees position
void beforeCloseDoor() {
  servoSpider.write(0);
  delay(20);
}
//When this function is called the door will close and the lights will turn off
void closeDoor() {
  servoDoor.write(0);
  digitalWrite(7, LOW);
  open = false;
}